#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct CheckOriginMetadata {
    #[serde(rename = "checkEvaluationRid")]
    check_evaluation_rid: conjure_object::ResourceIdentifier,
    #[serde(rename = "checkRid")]
    check_rid: super::super::scout::rids::api::CheckRid,
    #[serde(rename = "checkLineageRid")]
    check_lineage_rid: super::super::scout::rids::api::CheckLineageRid,
    #[builder(default, into)]
    #[serde(
        rename = "implementationIndex",
        skip_serializing_if = "Option::is_none",
        default
    )]
    implementation_index: Option<i32>,
}
impl CheckOriginMetadata {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        check_evaluation_rid: conjure_object::ResourceIdentifier,
        check_rid: super::super::scout::rids::api::CheckRid,
        check_lineage_rid: super::super::scout::rids::api::CheckLineageRid,
    ) -> Self {
        Self::builder()
            .check_evaluation_rid(check_evaluation_rid)
            .check_rid(check_rid)
            .check_lineage_rid(check_lineage_rid)
            .build()
    }
    #[inline]
    pub fn check_evaluation_rid(&self) -> &conjure_object::ResourceIdentifier {
        &self.check_evaluation_rid
    }
    #[inline]
    pub fn check_rid(&self) -> &super::super::scout::rids::api::CheckRid {
        &self.check_rid
    }
    #[inline]
    pub fn check_lineage_rid(&self) -> &super::super::scout::rids::api::CheckLineageRid {
        &self.check_lineage_rid
    }
    #[inline]
    pub fn implementation_index(&self) -> Option<i32> {
        self.implementation_index.as_ref().map(|o| *o)
    }
}
